#include <avr/io.h>
#include <util/delay.h>

#define AREF 5
#define FRECVENTA 1000000

int frecvente_note[7] = {
	421, 512, 659, 721, 790, 820, 9835
};

int get_ADC(uint8_t channel)
{
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;
	ADCSRA |= (1 << ADSC);
	while(ADCSRA & (1 << ADSC));
	return ADC;
}

void play()
{
	int perioada;
	int j;
	int value;
	
	while (1) {
		int i;
		double voltage_value;
		
		for (i = 0; i < 7; i++) {
		    value = get_ADC(i);
			voltage_value = value * AREF / 1024;
			
			if (voltage_value > 2.5) {
				perioada = FRECVENTA / frecvente_note[i];
	
				PORTD |= (1 << PD5);
				for (j = 0; j < perioada / 2; j++)
					_delay_us(2);
				
				PORTD &= ~(1 << PD5);
				
				for (j = 0 ; j < perioada / 2; j++)
					_delay_us(2);
			}
		}
	}
}

int main(void) {

	DDRB |= (1 << PD5);
	PORTB &= ~(1 << PD5);
	
	DDRA &= ~(1 << PA1);
	DDRA &= ~(1 << PA2);
	DDRA &= ~(1 << PA3);
	DDRA &= ~(1 << PA4);
	DDRA &= ~(1 << PA5);
	DDRA &= ~(1 << PA6);
	DDRA &= ~(1 << PA7);

	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);

	ADMUX = (1 << REFS0);
	ADCSRA = (1 << ADEN) | (7 << ADPS0);
	
	play();

	return 0;
}
